<?php
	lt_include( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
	lt_include( PLOG_CLASS_PATH."class/template/templatesets/templatesets.class.php" );
	lt_include( PLOG_CLASS_PATH."class/template/templatesets/templatesetstorage.class.php" );		
	lt_include( PLOG_CLASS_PATH."plugins/templateeditor/class/view/pluginsitetemplatesetslistview.class.php" );
    lt_include( PLOG_CLASS_PATH."plugins/templateeditor/class/file/myfile.class.php" );	
	lt_include( PLOG_CLASS_PATH."class/data/validator/templatesetnamevalidator.class.php" );

    /**
     * Removes global templates from disk.
     */
    class PluginSiteCopyTemplateSetAction extends AdminAction
    {

        function PluginSiteCopyTemplateSetAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );

			$this->requireAdminPermission( "edit_global_templates" );

            $this->registerFieldValidator( "templateId", new TemplateSetNameValidator());
            $this->registerFieldValidator( "newTemplateId", new TemplateSetNameValidator());

            $view = new PluginSiteTemplateSetsListView( $this->_blogInfo );
                // Note, error message will be wrong if the type value is incorrect
            $view->setErrorMessage( $this->_locale->tr("templateeditor_error_templateset_name"));
            $this->setValidationErrorView( $view );
        }

        function perform()
        {
            $templateId = $this->_request->getValue( "templateId" );
            $newTemplateId = $this->_request->getValue( "newTemplateId" );

                // get a list with all the global template sets
        	$ts = new TemplateSets();
            $globalTemplates = $ts->getGlobalTemplateSets();
            
            foreach ($globalTemplates as $template) {
                if ( $template->getName() == $newTemplateId ) {
                	$this->_view = new PluginSiteTemplateSetsListView( $this->_blogInfo );
                	$this->_view->setErrorMessage( $this->_locale->tr("error_duplicate_templateset_name"));
                    $this->setCommonData();
                    return false;
                }
            }

        	$ts = new TemplateSetStorage();
            $blogId = $this->_blogInfo->getId();
            $sourceTemplateFolder = $ts->getTemplateFolder($templateId);
            $newTemplateFolder = $ts->getBaseTemplateFolder() . "/" . $newTemplateId;
            
            if ( MyFile::copyDir($sourceTemplateFolder, $newTemplateFolder) ) {
                $ts->addTemplate($newTemplateId);
            } else {
                File::deleteDir($newTemplateFolder);
                $this->_view = new PluginSiteTemplateSetsListView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("error_copying_templateset"));
                $this->setCommonData();
                return false;                
            }

			// if everything went ok...
            $this->_session->setValue( "blogInfo", $this->_blogInfo );
            $this->saveSession();
            
			$this->_view = new PluginSiteTemplateSetsListView( $this->_blogInfo );
			$this->_view->setSuccessMessage( $this->_locale->tr("templateeditor_templateset_copyed_ok"));
			$this->setCommonData();
			
			// clear the cache
			CacheControl::resetBlogCache( $this->_blogInfo->getId());			
            
            return true;
        }

    }
?>
